<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Constructors</title>
</head>
<body>
  <div class="wrap" id="main">
    <!-- <div>
      <form id="main">
  
        <label for="author">
          <span>Author</span>
          <select name="author">
            <option value="Taras Shevchenko">Taras Shevchenko</option>
            <option value="Ivan Franko">Ivan Franko</option>
            <option value="Vasyl Stys">Vasyl Stys</option>
            <option value="Oles Gonchar">Oles Gonchar</option>
          </select>
        </label>
  
        <label for="message-area">
          <span>Message</span>
          <textarea placeholder="Your Message" name="message_area"></textarea>
        </label>
  
        <button id="submit" type="submit">Send Message</button>
      </form>
      <ul class="message_list">
      </ul>
    </div> -->
  </div>



  <script>

    function getForm(id){ 
      return `
          <form name="${id}">
          <label for="author">
            <span>Author</span>
            <select class="author" name="author">
              <option value="Taras Shevchenko">Taras Shevchenko</option>
              <option value="Ivan Franko">Ivan Franko</option>
              <option value="Vasyl Stys">Vasyl Stys</option>
              <option value="Oles Gonchar">Oles Gonchar</option>
            </select>
          </label>

          <label for="message-area">
            <span>Message</span>
            <textarea placeholder="Your Message" name="message_area"></textarea>
          </label>

          <button class="submit" type="submit" data-id="${id}">Send Message</button>
        </form>
        <ul class="message_list">
      </ul>
        `};

    function uuidv4() {
      return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function(c) {
        var r = Math.random() * 16 | 0, v = c == 'x' ? r : (r & 0x3 | 0x8);
        return v.toString(16);
      });
    }

    class Message{
      constructor(author, text) { 
        this.date = new Date();
        this.id = uuidv4();
        this.author = author;
        this.text = text;
        this.answers = [];
      }
      SkipMessage() { // которое должно найти сообщение и удалить его из массива.
        let elem = document.getElementById(this.id);
        elem.parentElement.remove(elem);
        messageArray = messageArray.filter(x=>x.id!=this.id);
        console.log(messageArray);
      }

      AnswerMessage(id, targetBlock) { // -> должно открыть поле ввода, в который вы сможете ввести ответ
        // Усли уже ыбла форма то сделаем ее видимой
        let form = targetBlock.getElementsByTagName('form')[id];
        if(!form) {
          let div = document.createElement('div'); 
          div.innerHTML = getForm(id);
          targetBlock.appendChild(div);
          let targetForm = targetBlock.getElementsByTagName('form');
          form = targetForm[id];
          form.addEventListener('submit',(e)=>{
            e.preventDefault();
            let mess = new Answer(e.target.author.value, e.target.message_area.value);
            messageArray.push(mess);
            e.target.message_area.value = '';
            let message_list = e.target.parentElement.querySelector('.message_list');
            
            mess.render(message_list);
            e.target.style.visibility = "hidden";
          });
        } else {
          form.style.visibility = "visible";
        }
        
       
      }

      // SendAnswer(author, text) { // метод который «отравляет» ответ, при этом обновляя поле ответа(answers) в вашем объекте с сообщением.
        
      //   let answer = new Answer(author, text, this.id);
      //   this.answers.push(answer);
      //   return answer;
      // }

      render(target){
        let renderHTML =  `<li id="${this.id}">
            <div class="message_date">
              ${this.date.toLocaleDateString('ru-RU')+' '+this.date.toLocaleTimeString('ru-RU')}
            </div>
            <div class="message_author">
              <b>${this.author}</b>
            </div>
            <div class="message_text">
              ${this.text}
            </div>
            <div class="message_controls">
              <button class="_skipMessage" data-id="${this.id}">Skip</button>
              <button class="_answerMessage" data-id="${this.id}">Answer</button>
            </div>
            <div style="padding-left:20px; border-left:1px solid #000" class="message_answer">
            </div>
        </li>`
        let div = document.createElement('div');
        div.innerHTML = renderHTML;
        target.appendChild(div);

        let _skipMessage = target.querySelectorAll('._skipMessage');
        _skipMessage.forEach((elem) => {
          if(elem.dataset.id === this.id){
            elem.addEventListener('click', () => {
              this.SkipMessage();
            });
          }
        });

         let _answerMessage = div.querySelector('._answerMessage');
         console.log(_answerMessage);
         let message_answer = div.querySelector('.message_answer');
         _answerMessage.addEventListener('click', (e) => {
             //console.log(e.target.dataset.id);
             //let message 
             this.AnswerMessage(e.target.dataset.id, message_answer);
             
        });

      }
    }
    class Answer extends Message {
      constructor(author, text, parentId) {
        super(author, text);
        this.parentId = parentId;
      }
      SkipMessage() { // которое должно найти сообщение и удалить его из массива.
        let elem = document.getElementById(this.id);
        elem.parentElement.remove(elem);
        //messageArray = messageArray.filter(x=>x.id!=this.id);
        //console.log(messageArray);
      }
    }


    let messageArray = [];
    let main = document.getElementById('main');
    main.innerHTML = getForm("main");
    let targetForm = main.getElementsByTagName('form');
    targetForm["main"].addEventListener('submit', (e) => {
        e.preventDefault();
        // if (!e.target.message_area.value || e.target.message_area.value.length === 0) {
        //   alert('Введите сообщение');
        //   return;
        // }
        let mess = new Message(e.target.author.value, e.target.message_area.value);
        messageArray.push(mess);
        e.target.message_area.value = '';
        let message_list = e.target.parentElement.querySelector('.message_list')
        mess.render(message_list);
      });
    



    // document.forms.main.addEventListener('submit', (e)=>{
    //   e.preventDefault();
    //   if(!e.target.message_area.value || e.target.message_area.value.length===0) {
    //     alert('Введите сообщение');
    //     return;
    //   }
    //   let mess = new Message(e.target.author.value, e.target.message_area.value);
    //   messageArray.push(mess);
    //   e.target.message_area.value = '';
    //   let message_list = e.target.parentElement.querySelector('.message_list')
    //   mess.render(message_list);
    // });  
  /*
    Задание на классы.

    Создать класс Message конструктор котрого состоит из следующих полей:
    id, author, text, date, answers

    У этого класса будет два метода:
    SkipMessage() -> которое должно найти сообщение и удалить его из массива.
    AnswerMessage()-> должно отрыть поле ввода, в который вы сможете ввести ответ
    SendAnswer() -> метод который «отравляет» ответ, при этом обновляя поле ответа(answers) в вашем объекте с сообщением.

    В метод SendAnswer нужно передать обьект класса Answer который наследуется от класса Message,
    Но еще дополнительно будет иметь поле parentId.


    message = {
      id: '',
      author: '',
      text: '',
      date: '',
      answers: [
        {
          id: '',
          author: '',
          text: '',
          date: '',
          parentId: '',
          answers: ''
        }
      ]
    }

    +Bonus: После создании сообщение добавляется в массив со всеми сообщениями, которые потом будут выводится на экран.

    _ _ _

    Задание можно разбелить на две части:
      1. Создание самого сообщения:
      id->выдаётся автоматом
      Author-> селект с выбором автора
      Text -> текст сообщения
      date -> автоматически в момент создания

      Все данные беруться с формы. Массив с сообщениями передается в функцию рендера, которая генерирует сам список.

      2. Ответ на сообщение

  */

  </script>
</body>
</html>
